;      
;  - PIC16F628 (  4 M),  - 107,  - DS18S20
; : , 1, 2, , 
; :  SETUP (  )  +/Timers ( /   )
; 6  ,    (  -  )
;    -     ,  +-1 
;      (    1-3    0.5
;    -  

 	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _LVP_OFF & _DATA_CP_OFF & _MCLRE_OFF &_BODEN_OFF
#include p16f628.inc
#define lcd_rs		PORTB,4		; / (LCD 1)
#define	lcd_e		PORTB,5		;  (LCD 3)
#define	THERMO  	PORTA,2		; 
#define LIGHT_PIN	PORTA,6		;  ( 6,  0,  6)
#define HEAT_PIN	PORTA,1		;  ( 7,  7,  1)
#define COOL_PIN	PORTA,3		;  ( 3,  6,  3)
#define LOAD1_PIN	PORTA,7		; 1 ( 1,  1,  7)
#define LOAD2_PIN	PORTA,0		; 2 ( 0,  3,  0)
#define POWER		PORTB,7		; 

#define	CARRY		STATUS,C
#define	ZERO 		STATUS,Z

#define KEY_SET		flags,7		;  SET
#define KEY_MODE	flags,6		;  MODE
#define DS_ERR		flags,5		; 
#define CORR_BIT	flags,4		;0-  , 1- 
#define OLD_TIME	flags,3		;     
#define NEW_TIME	flags,2		;     
#define ON_LOAD		flags,1		;  
#define OFF_LOAD	flags,0		;  

#define LIGHT		loads,0		;  
#define LOAD1		loads,1		;  1 
#define LOAD2		loads,2		;  2 
#define HEATER		loads,3		;  
#define COOLER		loads,4		;   (  )
#define COOL_ON		loads,5		;  
#define T5_ON		loads,6		;   5
#define T6_ON		loads,7		;   6


INIT_OPTION	EQU	b'00000100'	;
INIT_INTCON	EQU	b'10100000'	;
INIT_T1CON	EQU	b'00000011'	; TMR1  .., ., .. 1:1
INIT_CMCON	EQU	b'00000111'	; 
	cblock 0x20
		d0,d1,d2,d3,d4,d5,d6,d7,d8,d9 	; 
		w_tmp		;  W
		status_tmp	;---- STATUS
		count		; 
		count2		
		hours		;   (HEX)
		minutes		
		seconds
		sec_therm	;  
		screen	;   
			;0  : -     	   /25 12-00/
			;1  :   /25 L12HC//25 -----/
			;2  :        /LIGHt  On //LIGHt  OFF/
			;3  :   1 /LOAd1  On //LOAd1  OFF/	
			;4  :   2 /LOAd2  On //LOAd2  OFF/
			;5  :  .    /Min t 22/
			;6  :  .   /MAH t 26/	
			;7  :   		   /Hour 12-00/
			;8  :   		   /Min 12-00/
			;9  :  	   	   /Corr-00SEC/
			;10 :  ( )
			;11 :  ( ) 
			;12 : 1 . 	   /t1     OFF//t1   LIGHt//t1   LOAd1//t1   LOAd2/
			;13 : 1 .   	   /t1On 12-00/
			;14 : 1 .      /t1OFF12-00/
			;15 : 2 . 	   /t2     OFF//t2   LIGHt//t1   LOAd1//t1   LOAd2/
			;16 : 2 .   	   /t2On 12-00/
			;17 : 2 .      /t2OFF12-00/
			;18 : 3 . 	   /t3     OFF//t3   LIGHt//t1   LOAd1//t1   LOAd2/
			;19 : 3 .   	   /t3On 12-00/
			;20 : 3 .      /t3OFF12-00/
			;21 : 4 . 	   /t4     OFF//t4   LIGHt//t1   LOAd1//t1   LOAd2/
			;22 : 4 .   	   /t4On 12-00/
			;23 : 4 .      /t4OFF12-00/
			;24 : 5 . 	   /t5     OFF//t5   LIGHt//t1   LOAd1//t1   LOAd2/
			;25 : 5 .   	   /t5On 12-00/
			;26 : 5 .      /t5OFF12-00/
			;27 : 6 . 	   /t6     OFF//t6   LIGHt//t1   LOAd1//t1   LOAd2/
			;28 : 6 .   	   /t6On 12-00/
			;29 : 6 .      /t6OFF12-00/
				
		max_temp 	;  
		min_temp 	;  
		ret_count	;  
		hexdata		;HEX   
		hunds		;  
		decs	 	;  
		ones	 	;  
		dstemp		;  
		sendbyte	;  
		reseivebyte	;  
		newpress	; 
		oldpress	;,    
		flags		; 
		loads		;   
		temp		; 
		hr_tmp		;      
		min_tmp		;      
		sec_tmp		;      
		time_corr	;  
		set_count	;  SET
	endc

	cblock 0x5f
		hr_on1, hr_on2, hr_on3, hr_on4, hr_on5, hr_on6
		hr_off1, hr_off2, hr_off3, hr_off4, hr_off5, hr_off6
		min_on1, min_on2, min_on3, min_on4, min_on5, min_on6
		min_off1, min_off2, min_off3, min_off4, sec_off5, sec_off6
		load1, load2, load3, load4, load5, load6
		sec_cnt5, sec_cnt6
		
	endc
				
; MACROS
ds_comm		macro		;   
		bcf PORTA,2
		bsf STATUS,RP0
		bcf TRISA^80h,2
		bcf STATUS,RP0
		endm

ds_data		macro		;   
		bsf STATUS,RP0
		bsf TRISA^80h,2
		bcf STATUS,RP0
		endm



	org 0x000
	goto begin
;  
timeint		org 0x004			
		movwf w_tmp		; STATUS, W
		swapf STATUS,W
		clrf STATUS
		movwf status_tmp
		
		btfss TMR1H,7 ; ( 3,  7)
		goto press
		incf seconds
		incf sec_therm
		bcf TMR1H,7 ;( 3,  7)
		incf ret_count		;  -    
		
		movf sec_cnt5,0		;    5  6
		btfss ZERO
		decf sec_cnt5
		call ctrl_off5
			
		movf sec_cnt6,0
		btfss ZERO
		decf sec_cnt6
		call ctrl_off6
		
		
press		movf newpress,0
		movwf oldpress
		movf PORTA,0
		andlw b'00110000'
		movwf newpress
		subwf oldpress,0
		btfsc  ZERO
		goto no_press
setpress	btfsc newpress,5
		goto press_mode
		bsf KEY_SET
		bcf KEY_MODE
		incf set_count
		goto end_key
press_mode	clrf set_count
		btfsc newpress,4
		goto no_press
		bcf KEY_SET
		bsf KEY_MODE
		goto end_key
no_press	bcf KEY_SET
		bcf KEY_MODE
end_key
		btfsc PORTA,5
		goto no_time_inc
		incf set_count
		movf set_count,0
		sublw .30		;  +/Timers
		btfss ZERO
		goto no_time_inc
		bsf KEY_SET
		clrf set_count
		

		
no_time_inc	
		swapf status_tmp,W	; STATUS, W
		movwf STATUS	
		swapf w_tmp,F
		swapf w_tmp,W
		bcf INTCON,2
		clrwdt	
		
	retfie		; 


seg7		;    7-
		addwf PCL
		dt 0EEh, 060h, 02Fh, 06Dh, 0E1h; 0,1,2,3,4
		dt 0CDh, 0CFh, 068h, 0EFh, 0EDh; 5,6,7,8,9
		; 
msg_tab		addwf PCL		
		dt 0x00, 0x00, 0xee, 0x8b, 0x8b					; OFF 		0
		dt 0x00, 0x00, 0xee, 0x43, 0x00					; On  		5
		dt 0x86, 0x60, 0xce, 0xe3, 0x87					; LIGHt		10
		dt 0x86, 0xee, 0xeb, 0x67, 0x60					; LOAd1		15
		dt 0x86, 0xee, 0xeb, 0x67, 0x2f					; LOAd2		20
		dt 0xaa, 0xe8, 0xeb, 0xe3, 0x00, 0x87, 0xa9		; MAH t	25
		dt 0xaa, 0xe8, 0x40, 0x43, 0x00, 0x87, 0xa9		; Min t	32
		dt 0xe3, 0x47, 0x46, 0x03, 0x00					; Hour		39
		dt 0xaa, 0xe8, 0x40, 0x43, 0x00					; Min		44
		dt 0x8e, 0x47, 0x03, 0x03, 0x00, 0x00, 0x00, 0xcd, 0x8f, 0x8e	; Corr   SEC	49





begin					; PIC
		bsf STATUS,RP0
		movlw 0x30
		movwf TRISA^80h
		movlw b'11000000'
		movwf TRISB^80h
		movlw INIT_OPTION
		movwf OPTION_REG^80h
		bcf STATUS,RP0
		movlw INIT_INTCON
		movwf INTCON
		movlw INIT_T1CON
		movwf T1CON
		movlw INIT_CMCON
		movwf CMCON
		clrf STATUS
		
					; 
		movlw 0x0F
		call lcd_cw
		movlw 1
		call lcd_dw

					;    WDT?
		btfss STATUS,4
		goto main_loop		;   

		; 
		movlw .12
		movwf hours
		movlw .30
		call flash_rd
		movwf min_temp
		movlw .31
		call flash_rd
		movwf max_temp
		movlw .32
		call flash_rd
		movwf time_corr
		clrf minutes
		clrf seconds
		clrf sec_therm
		clrf TMR1L
		clrf TMR1H
		clrf flags
		clrf loads
		clrf newpress
		clrf oldpress
		clrf screen
		movlw 0x5f	; 
		movwf FSR
		movlw .30
		movwf count
nextimer 	decf count,0
		call flash_rd
		movwf INDF	
		incf FSR
		decfsz count
		goto nextimer



; 
main_loop
		
	
; 	
clock		movf sec_therm,0	; 10  -  
		sublw .10
		btfss ZERO
		goto sec_count
		call thermometer	
		clrf sec_therm

sec_count	movf seconds,0
		sublw .60
		btfss ZERO
		goto end_time
		incf minutes
		clrf seconds
		call tmr_ctrl
		movf minutes,0
		sublw .60
		btfss ZERO
		goto end_time
		incf hours
		clrf minutes
		call tmr_ctrl
		movf hours,0
		sublw .24
		btfss ZERO
		goto end_time
		clrf hours
		call corr		; 
		
end_time
		movf hours,0
		sublw .1
		btfss ZERO
		goto ret_scr
		bcf CORR_BIT		; 1  -   
		
ret_scr		movf ret_count,0	;   60 ?
		sublw .60 ;(60)
		btfsc ZERO
		clrf screen		;   
end_ret_menu
		

;   

; SETUP
		btfss KEY_SET
		goto keymode
		clrf ret_count

set0		movf screen,0	; 0    
		btfss ZERO
		goto set2
		movlw .12
		movwf screen	
		goto off_key

		
set2		movf screen,0	; 1    /LIGHt  On //LIGHt OFF/
		sublw .2
		btfss ZERO
		goto set3
		btfss LIGHT
		goto light_on
		bcf LIGHT
		goto off_key	
light_on	bsf LIGHT	
		goto off_key

set3		movf screen,0	; 2   1 /LOAd1  On //LOAd1 OFF/
		sublw .3
		btfss ZERO
		goto set4
		btfss LOAD1
		goto load1_on
		bcf LOAD1
		goto off_key	
load1_on	bsf LOAD1	
		goto off_key		
		
set4		movf screen,0	; 3   2 /LOAd2  On //LOAd2 OFF/
		sublw .4
		btfss ZERO
		goto set5
		btfss LOAD2
		goto load2_on
		bcf LOAD2
		goto off_key	
load2_on	bsf LOAD2	
		goto off_key		
		
set5		movf screen,0	; 4 . 	/Min t 24/
		sublw .5
		btfss ZERO
		goto set6
		incf min_temp
		movf min_temp,0
		sublw .50
		btfsc ZERO
		call min20deg
		movf min_temp,0
		addlw .2
		movwf max_temp
		goto off_key

set6		movf screen,0	; 5 . 	/MAH t 26/
		sublw .6
		btfss ZERO
		goto set7
		incf max_temp
		movf max_temp,0
		sublw .50
		btfsc ZERO
		call max20deg
		goto off_key		
	
set7		movf screen,0	; 6   /Hour 12-00/
		sublw .7
		btfss ZERO
		goto set8
		incf hours
		movf hours,0
		sublw .24
		btfsc ZERO
		clrf hours
		goto off_key		
	
set8		movf screen,0	; 7   /Min  12-00/
		sublw .8
		btfss ZERO
		goto set9
		incf minutes
		clrf seconds
		movf minutes,0
		sublw .60
		btfsc ZERO
		clrf minutes
		goto off_key

set9		movf screen,0	; 9   /Corr 00SEC/
		sublw .9
		btfss ZERO
		goto set12
		incf time_corr
		movf time_corr,0
		sublw .60
		btfsc ZERO
		call minus59
		goto off_key	

set12		movf screen,0	; 10 1 . /t1     OFF//t1   LIGHt//t1   LOAd1//t1   LOAd2/
		sublw .12
		btfss ZERO
		goto set13
		incf load1,0
		andlw .3
		movwf load1
		goto off_key	

set13		movf screen,0	; 11 1 .  /On   12-00/	
		sublw .13
		btfss ZERO
		goto set14
		movlw .15
		addwf min_on1
		movf min_on1,0
		sublw .60
		btfss ZERO
		goto copy_off1
		clrf min_on1
		incf hr_on1
		movf hr_on1,0
		sublw .24
		btfsc ZERO
		clrf hr_on1
copy_off1	movf hr_on1,0
		movwf hr_off1
		movf min_on1,0
		movwf min_off1
		goto off_key		
	
set14		movf screen,0	; 12 1 .  /OFF  12-00/			
		sublw .14
		btfss ZERO
		goto set15
		movlw .15
		addwf min_off1
		movf min_off1,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_off1
		incf hr_off1
		movf hr_off1,0
		sublw .24
		btfsc ZERO
		clrf hr_off1
		goto off_key		
	
set15		movf screen,0	; 13 2 . /t2     OFF//t2   LIGHt//t2   LOAd1//t2  LOAd2/	
		sublw .15
		btfss ZERO
		goto set16
		incf load2,0
		andlw .3
		movwf load2
		goto off_key		
	
set16		movf screen,0	; 14 2 .  /On   12-00/	
		sublw .16
		btfss ZERO
		goto set17
		movlw .15
		addwf min_on2
		movf min_on2,0
		sublw .60
		btfss ZERO
		goto copy_off2
		clrf min_on2
		incf hr_on2
		movf hr_on2,0
		sublw .24
		btfsc ZERO
		clrf hr_on2
copy_off2	movf hr_on2,0
		movwf hr_off2
		movf min_on2,0
		movwf min_off2
		goto off_key		
	
set17		movf screen,0	; 15 2 .  /OFF  12-00/		
		sublw .17
		btfss ZERO
		goto set18
		movlw .15
		addwf min_off2
		movf min_off2,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_off2
		incf hr_off2
		movf hr_off2,0
		sublw .24
		btfsc ZERO
		clrf hr_off2
		goto off_key		
	
set18		movf screen,0	; 16 3 . /t3     OFF//t3   LIGHt//t3   LOAd1//t3   LOAd2/
		sublw .18
		btfss ZERO
		goto set19
		incf load3,0
		andlw .3
		movwf load3
		goto off_key		
	
set19		movf screen,0	; 17 3 .  /On   12-00/
		sublw .19
		btfss ZERO
		goto set20
		movlw .15
		addwf min_on3
		movf min_on3,0
		sublw .60
		btfss ZERO
		goto copy_off3
		clrf min_on3
		incf hr_on3
		movf hr_on3,0
		sublw .24
		btfsc ZERO
		clrf hr_on3
copy_off3	movf hr_on3,0
		movwf hr_off3
		movf min_on3,0
		movwf min_off3
		goto off_key		
	
set20		movf screen,0	; 18 3 .  /OFF  12-00/	
		sublw .20
		btfss ZERO
		goto set21
		movlw .15
		addwf min_off3
		movf min_off3,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_off3
		incf hr_off3
		movf hr_off3,0
		sublw .24
		btfsc ZERO
		clrf hr_off3
		goto off_key		
	
set21		movf screen,0	; 19 4 . /t4     OFF//t4   LIGHt//t4   LOAd1//t4   LOAd2/
		sublw .21
		btfss ZERO
		goto set22
		incf load4,0
		andlw .3
		movwf load4
		goto off_key		
	
set22		movf screen,0	; 20 4 .  /On   12-00/
		sublw .22
		btfss ZERO
		goto set23
		movlw .15
		addwf min_on4
		movf min_on4,0
		sublw .60
		btfss ZERO
		goto copy_off4
		clrf min_on4
		incf hr_on4
		movf hr_on4,0
		sublw .24
		btfsc ZERO
		clrf hr_on4
copy_off4	movf hr_on4,0
		movwf hr_off4
		movf min_on4,0
		movwf min_off4
		goto off_key		
	
set23		movf screen,0	; 21 4 .  /OFF  12-00/	
		sublw .23
		btfss ZERO
		goto set24
		movlw .15
		addwf min_off4
		movf min_off4,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_off4
		incf hr_off4
		movf hr_off4,0
		sublw .24
		btfsc ZERO
		clrf hr_off4
		goto off_key		
	
set24		movf screen,0	; 22 5 . /t5     OFF//t5   LIGHt//t5   LOAd1//t5   LOAd2/
		sublw .24
		btfss ZERO
		goto set25
		incf load5,0
		andlw .3
		movwf load5
		goto off_key		
	
set25		movf screen,0	; 23 5 .  /On   12-00/
		sublw .25
		btfss ZERO
		goto set26
		movlw .15
		addwf min_on5
		movf min_on5,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_on5
		incf hr_on5
		movf hr_on5,0
		sublw .24
		btfsc ZERO
		clrf hr_on5
		goto off_key		
	
set26		movf screen,0	; 24 5 .  /OFF    010/	
		sublw .26
		btfss ZERO
		goto set27
		incf sec_off5
		btfss ZERO
		goto off_key
		movlw 1
		movwf sec_off5
		goto off_key		
	
set27		movf screen,0	; 25 6 . /t6     OFF//t6   LIGHt//t6   LOAd1//t6   LOAd2/
		sublw .27
		btfss ZERO
		goto set28
		incf load6,0
		andlw .3
		movwf load6
		goto off_key		
	
set28		movf screen,0	; 26 6 .  /On   12-00/
		sublw .28
		btfss ZERO
		goto set29
		movlw .15
		addwf min_on6
		movf min_on6,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf min_on6
		incf hr_on6
		movf hr_on6,0
		sublw .24
		btfsc ZERO
		clrf hr_on6
		goto off_key		
	
set29		movf screen,0	; 27 6 .  /OFF    010/	
		sublw .29
		btfss ZERO
		goto off_key
		incf sec_off6
		btfss ZERO
		goto off_key
		movlw 1
		movwf sec_off6
		goto off_key		
	
	
	
; +/Timers
keymode		btfss KEY_MODE
		goto off_key
		clrf ret_count
		incf screen

mode11		movf screen,0
		sublw .10
		btfss ZERO
		goto mode13
		movlw .30
		bsf STATUS,RP0
		movwf EEADR
		bcf STATUS,RP0
		movf min_temp,0
		bsf STATUS,RP0
		movwf EEDATA
		bcf STATUS,RP0
		call flash_wr
		movlw .31
		bsf STATUS,RP0
		movwf EEADR
		bcf STATUS,RP0
		movf max_temp,0
		bsf STATUS,RP0
		movwf EEDATA
		bcf STATUS,RP0
		call flash_wr
		movlw .32
		bsf STATUS,RP0
		movwf EEADR
		bcf STATUS,RP0
		movf time_corr,0
		bsf STATUS,RP0
		movwf EEDATA
		bcf STATUS,RP0
		call flash_wr
		clrf screen
		
mode13		movf screen,0
		sublw .13
		btfss ZERO
		goto mode16
		movf load1,0
		btfss ZERO
		goto mode16
		incf screen
		incf screen

mode16		movf screen,0
		sublw .16
		btfss ZERO
		goto mode19
		movf load2,0
		btfss ZERO
		goto mode19
		incf screen
		incf screen

mode19		movf screen,0
		sublw .19
		btfss ZERO
		goto mode22
		movf load3,0
		btfss ZERO
		goto mode22
		incf screen
		incf screen

mode22		movf screen,0
		sublw .22
		btfss ZERO
		goto mode25
		movf load4,0
		btfss ZERO
		goto mode25
		incf screen
		incf screen

mode25		movf screen,0
		sublw .25
		btfss ZERO
		goto mode28
		movf load5,0
		btfss ZERO
		goto mode28
		incf screen
		incf screen

mode28		movf screen,0
		sublw .28
		btfss ZERO
		goto mode30
		movf load6,0
		btfss ZERO
		goto mode30
		incf screen
		incf screen
		
mode30		movf screen,0
		sublw .30
		btfss ZERO
		goto off_key
		movlw 0x5f
		movwf FSR
		movlw .30
		movwf count
loop_wr		decf count,0
		bsf STATUS,RP0
		movwf EEADR
		bcf STATUS,RP0
		movf INDF,0
		bsf STATUS,RP0
		movwf EEDATA
		bcf STATUS,RP0
		call flash_wr
		incf FSR
		decfsz count
		goto loop_wr
		clrf screen
		


off_key		bcf KEY_SET
		bcf KEY_MODE



; 
		movf screen,0		; 0 - /25 12-00/
		btfss ZERO
		goto scr1
		btfsc DS_ERR
		goto therm_ok
		movlw 1
		movwf d0
		movwf d1
		goto next_scr
therm_ok	movf dstemp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7		;  7- 
		movwf d0
		movf ones,0
		call seg7		;  7- 
		movwf d1
next_scr	movlw b'10101001'
		movwf d2
		movlw b'00000111'
		movwf d3
		clrf d4
		movf hours,0
		movwf hr_tmp
		movf minutes,0
		movwf min_tmp
		call clk_out
		btfss TMR1H,6
		goto end_screen
		movlw 0
		movwf d7
		goto  end_screen

scr1		movf screen,0		; 1 - /25 L12HC//25      /
		sublw .1
		btfss ZERO
		goto scr2
		btfsc DS_ERR
		goto therm_ok1
		movlw 1
		movwf d0
		movwf d1
		goto next_scr1
therm_ok1	movf dstemp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7		;  7- 
		movwf d0
		movf ones,0
		call seg7		;  7- 
		movwf d1
next_scr1	movlw b'10101001'
		movwf d2
		movlw b'00000111'
		movwf d3
		clrf d4
		movlw 0x86
		movwf d5
		movlw 0x60
		movwf d6
		movlw 0x2f
		movwf d7
		movlw 0xe3
		movwf d8
		movlw 0x8e
		movwf d9
		btfss LIGHT
		clrf d5
		btfss LOAD1
		clrf d6
		btfss LOAD2
		clrf d7
		btfss HEATER
		clrf d8
		btfss COOLER
		clrf d9
		goto  end_screen

scr2		movf screen,0		; 2     /LIGHt  On //LIGHt  OFF/				
		sublw .2
		btfss ZERO
		goto scr3
		movlw .5		;- 
		movwf count
		movlw .10		;  
		movwf count2
		movlw 0			;
		call message
		
		btfsc LIGHT
		goto lig_show_on
		movlw .5		;- 
		movwf count
		movlw .0		;  
		movwf count2
		movlw .5		;
		call message
		goto end_screen
lig_show_on	movlw .5		;- 
		movwf count
		movlw .5		;  
		movwf count2
		movlw .5		;
		call message
		goto end_screen
			
scr3		movf screen,0		; 3   1 /LOAd1  On //LOAd1 OFF/
		sublw .3
		btfss ZERO
		goto scr4
		movlw .5		;- 
		movwf count
		movlw .15		;  
		movwf count2
		movlw 0			;
		call message
		btfsc LOAD1
		goto show_load1_on
		movlw .5		;- 
		movwf count
		movlw .0		;  
		movwf count2
		movlw .5		;
		call message
		goto end_screen
show_load1_on	movlw .5		;- 
		movwf count
		movlw .5		;  
		movwf count2
		movlw .5		;
		call message
		goto  end_screen

scr4		movf screen,0		; 4   2 /LOAd2  On //LOAd2 OFF/
		sublw .4
		btfss ZERO
		goto scr5
		movlw .5		;- 
		movwf count
		movlw .20		;  
		movwf count2
		movlw 0			;
		call message
		btfsc LOAD2
		goto show_load2_on
		movlw .5		;- 
		movwf count
		movlw .0		;  
		movwf count2
		movlw .5		;
		call message
		goto end_screen
show_load2_on	movlw .5		;- 
		movwf count
		movlw .5		;  
		movwf count2
		movlw .5		;
		call message
		goto  end_screen

scr5		movf screen,0		; 5 . 	/Min t 24/				
		sublw .5
		btfss ZERO
		goto scr6
		movlw .7		;- 
		movwf count
		movlw .32		;  
		movwf count2
		movlw 0			;
		call message
		movf min_temp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7
		movwf d8
		movf ones,0
		call seg7
		movwf d9
		clrf d7
		goto end_screen	
	
scr6		movf screen,0		; 6 . 	/MAH t 26/
		sublw .6
		btfss ZERO
		goto scr7
		movlw .7		;- 
		movwf count
		movlw .25		;  
		movwf count2
		movlw 0			;
		call message
		movf max_temp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7
		movwf d8
		movf ones,0
		call seg7
		movwf d9
		clrf d7
		goto  end_screen

scr7		movf screen,0		; 7   /Hour 12-00/
		sublw .7
		btfss ZERO
		goto scr8
		movlw .5		;- 
		movwf count
		movlw .39		;  
		movwf count2
		movlw 0			;
		call message
		movf hours,0
		movwf hr_tmp
		movf minutes,0
		movwf min_tmp
		call clk_out

		goto  end_screen

scr8		movf screen,0		; 8   /Min  12-00/ 
		sublw .8
		btfss ZERO
		goto scr9
		movlw .5		;- 
		movwf count
		movlw .44		;  
		movwf count2
		movlw 0			;
		call message
		movf hours,0
		movwf hr_tmp
		movf minutes,0
		movwf min_tmp
		call clk_out
		goto  end_screen
		
scr9		movf screen,0		; 9   /Corr 00SEC/ 
		sublw .9
		btfss ZERO
		goto scr12
		movlw .10		;- 
		movwf count
		movlw .49		;  
		movwf count2
		movlw 0			;
		call message
		btfsc time_corr,7
		goto neg_scr
pos_scr		clrf d4
		movf time_corr,0
		goto corr_conv
neg_scr		movlw .1
		movwf d4
		comf time_corr,0
		movwf temp
		incf temp,0
corr_conv	movwf hexdata
		call convert		
		movf decs,0
		call seg7		;  7- 
		movwf d5
		movf ones,0
		call seg7		;  7- 
		movwf d6
		goto  end_screen
		
scr12		movf screen,0		; 10 1 . /tr1    OFF//tr1  LIGHt//tr1  LOAd1//tr1  LOAd2/
		sublw .12
		btfss ZERO
		goto scr13
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0x60
		movwf d2
		clrf d3
		clrf d4
		movf load1,0
		call load_disp
		goto  end_screen

scr13		movf screen,0	; 11 1 .  /On   12-00/
		sublw .13
		btfss ZERO
		goto scr14
		call disp_on
		movf hr_on1,0
		movwf hr_tmp
		movf min_on1,0
		movwf min_tmp
		call clk_out
		goto  end_screen

scr14		movf screen,0	; 12 1 .  /OFF  12-00/			
		sublw .14
		btfss ZERO
		goto scr15
		call disp_off
		movf hr_off1,0
		movwf hr_tmp
		movf min_off1,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr15		movf screen,0	; 13 2 . /tr2    OFF//tr2  LIGHt//tr2  LOAd1//tr2  LOAd2/	
		sublw .15
		btfss ZERO
		goto scr16
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0x2f
		movwf d2
		clrf d3
		clrf d4
		movf load2,0
		call load_disp
		goto end_screen		
	
scr16		movf screen,0	; 14 2 .  /On   12-00/	
		sublw .16
		btfss ZERO
		goto scr17
		call disp_on
		movf hr_on2,0
		movwf hr_tmp
		movf min_on2,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr17		movf screen,0	; 15 2 .  /OFF  12-00/		
		sublw .17
		btfss ZERO
		goto scr18
		call disp_off
		movf hr_off2,0
		movwf hr_tmp
		movf min_off2,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr18		movf screen,0	; 16 3 . /tr3    OFF//tr3  LIGHt//tr3  LOAd1//tr3  LOAd2/
		sublw .18
		btfss ZERO
		goto scr19
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0x6d
		movwf d2
		clrf d3
		clrf d4
		movf load3,0
		call load_disp
		goto end_screen		
	
scr19		movf screen,0	; 17 3 .  /On   12-00/
		sublw .19
		btfss ZERO
		goto scr20
		call disp_on
		movf hr_on3,0
		movwf hr_tmp
		movf min_on3,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr20		movf screen,0	; 18 3 .  /OFF  12-00/	
		sublw .20
		btfss ZERO
		goto scr21
		call disp_off
		movf hr_off3,0
		movwf hr_tmp
		movf min_off3,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr21		movf screen,0	; 19 4 . /tr4    OFF//tr4  LIGHt//tr4  LOAd1//tr4  LOAd2/
		sublw .21
		btfss ZERO
		goto scr22
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0xe1
		movwf d2
		clrf d3
		clrf d4
		movf load4,0
		call load_disp
		goto end_screen		
	
scr22		movf screen,0	; 20 4 .  /On   12-00/
		sublw .22
		btfss ZERO
		goto scr23
		call disp_on
		movf hr_on4,0
		movwf hr_tmp
		movf min_on4,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr23		movf screen,0	; 21 4 .  /OFF  12-00/	
		sublw .23
		btfss ZERO
		goto scr24
		call disp_off
		movf hr_off4,0
		movwf hr_tmp
		movf min_off4,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr24		movf screen,0	; 22 5 . /tr5    OFF//tr5  LIGHt//tr5  LOAd1//tr5  LOAd2/
		sublw .24
		btfss ZERO
		goto scr25
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0xcd
		movwf d2
		clrf d3
		clrf d4
		movf load5,0
		call load_disp
		goto end_screen		
	
scr25		movf screen,0	; 23 5 .  /On   12-00/
		sublw .25
		btfss ZERO
		goto scr26
		call disp_on
		movf hr_on5,0
		movwf hr_tmp
		movf min_on5,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr26		movf screen,0	; 24 5 .  /OFF  12-00/	
		sublw .26
		btfss ZERO
		goto scr27
		call disp_off
		movf sec_off5,0
		movwf sec_tmp
		call sec_out
		goto end_screen		
	
scr27		movf screen,0	; 25 6 . /tr6    OFF//tr6  LIGHt//tr6  LOAd1//tr6  LOAd2/
		sublw .27
		btfss ZERO
		goto scr28
		movlw 0x87
		movwf d0
		movlw 0x03
		movwf d1
		movlw 0xcf
		movwf d2
		clrf d3
		clrf d4
		movf load6,0
		call load_disp
		goto end_screen		
	
scr28		movf screen,0	; 26 6 .  /On   12-00/
		sublw .28
		btfss ZERO
		goto scr29
		call disp_on
		movf hr_on6,0
		movwf hr_tmp
		movf min_on6,0
		movwf min_tmp
		call clk_out
		goto end_screen		
	
scr29		movf screen,0	; 27 6 .  /OFF  12-00/	
		sublw .29
		btfss ZERO
		goto end_screen
		call disp_off
		movf sec_off6,0
		movwf sec_tmp
		call sec_out
		
end_screen
;  
		movlw 0
		call lcd_cw
		movf d0,0
		call lcd_dw
		movf d1,0
		call lcd_dw
		movf d2,0
		call lcd_dw
		movf d3,0
		call lcd_dw
		movf d4,0
		call lcd_dw
		movf d5,0
		call lcd_dw
		movf d6,0
		call lcd_dw
		movf d7,0
		call lcd_dw
		movf d8,0
		call lcd_dw
		movf d9,0
		call lcd_dw

		
; 
heat_ctrl	movf min_temp,0
		subwf dstemp,0
		btfsc CARRY
		goto off_heat
		bsf HEATER
		goto end_heat
off_heat	movf dstemp,0
		subwf min_temp,0
		btfsc CARRY
		goto end_heat
		bcf HEATER
end_heat

; 
		movf dstemp,0
		subwf max_temp,0
		btfsc CARRY
		goto off_cool
		bsf COOLER
		goto end_cool
off_cool	movf max_temp,0
		subwf dstemp,0
		btfsc CARRY
		goto end_cool
		bcf COOLER
end_cool	
		
;  
		btfss COOLER
		goto cool_off
		bsf COOL_ON
		movf max_temp,0
		subwf dstemp,0
		sublw .2
		btfss CARRY
		goto power_ctrl
		btfsc TMR1H,2
		goto power_ctrl
cool_off	bcf COOL_ON
		
; 

		
power_ctrl	btfsc DS_ERR	;   -    
		goto ctrl_ok
		bcf HEATER		
		bcf COOLER
		bcf COOL_ON
ctrl_ok		btfss HEATER
		goto no_heat
		bsf HEAT_PIN
		goto cool_test
no_heat		bcf HEAT_PIN
cool_test	btfss COOL_ON
		goto no_cool
		bsf COOL_PIN
		goto light_test
no_cool		bcf COOL_PIN
light_test	btfss LIGHT
		goto no_light
		bsf LIGHT_PIN
		goto load1_test
no_light	bcf LIGHT_PIN
load1_test	btfss LOAD1
		goto no_load1
		bsf LOAD1_PIN
		goto load2_test
no_load1	bcf LOAD1_PIN
load2_test	btfss LOAD2
		goto no_load2
		bsf LOAD2_PIN
		goto end_power
no_load2	bcf LOAD2_PIN
end_power
		
		; 
		btfsc POWER
		goto power_on
		bsf STATUS,RP0
		movlw 0xFF
		movwf TRISA^80h
		bcf STATUS,RP0
		goto end_main_cycle
power_on	bsf STATUS,RP0
		movlw 0x30
		movwf TRISA^80h
		bcf STATUS,RP0
				
end_main_cycle	goto main_loop

thermometer	call init_therm
		btfsc DS_ERR
		goto ds_enable
		movlw 0xFF	
		movwf dstemp
		goto end_thermo
ds_enable	movlw 0xCC	; 
		call send
		movlw 0xBE
		call send
		call reseive
		movwf dstemp
		call reseive
		movwf temp
		call init_therm ; 
		movlw 0xCC	; 
		call send
		movlw 0x44
		call send
		rrf dstemp
		bcf dstemp,7
end_thermo	return	
init_therm	; 
		bsf DS_ERR	;,   
		movlw .20	;  
		movwf count2
		ds_comm
		bcf THERMO	;
	  	movlw .170	; 500 
		movwf count
delinittherm	decfsz count
		goto delinittherm
		bsf THERMO
		ds_data
init_ansv	btfss THERMO	; 
		goto end_ansv
		decfsz count2
		goto init_ansv
		bcf DS_ERR	;   >  
		return
end_ansv	btfss THERMO	;  
		goto end_ansv
		return
send		; 
		movwf sendbyte	;  
		movlw .8
		movwf count2
sendloop	ds_comm
		rrf sendbyte
		btfsc CARRY
		bsf THERMO
		call wait50
		ds_data
		decfsz count2
		goto sendloop
		return
reseive		;  		
		movlw .8
		movwf count2
reseiveloop	ds_comm
		ds_data
		bcf CARRY
		btfsc THERMO
		bsf CARRY
		rrf reseivebyte 
		call wait50	
		decfsz count2
		goto reseiveloop
		movf reseivebyte,0
		return

; 
	

tmr_ctrl	movf hr_on1,0
		movwf hr_tmp
		movf min_on1,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_on2
		movf load1,0
		btfsc ZERO
		goto ctrl_on2
		sublw .1
		btfss ZERO
		goto tr1_ld1
		bsf LIGHT
		goto ctrl_on2
tr1_ld1		movf load1,0
		sublw .2
		btfss ZERO
		goto tr1_ld2
		bsf LOAD1
		goto ctrl_on2
tr1_ld2		bsf LOAD2
ctrl_on2	movf hr_on2,0
		movwf hr_tmp
		movf min_on2,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_on3
		movf load2,0
		btfsc ZERO
		goto ctrl_on3
		sublw .1
		btfss ZERO
		goto tr2_ld1
		bsf LIGHT
		goto ctrl_on3
tr2_ld1		movf load2,0
		sublw .2
		btfss ZERO
		goto tr2_ld2
		bsf LOAD1
		goto ctrl_on3
tr2_ld2		bsf LOAD2
ctrl_on3	movf hr_on3,0
		movwf hr_tmp
		movf min_on3,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_on4
		movf load3,0
		btfsc ZERO
		goto ctrl_on4
		sublw .1
		btfss ZERO
		goto tr3_ld1
		bsf LIGHT
		goto ctrl_on4
tr3_ld1		movf load3,0
		sublw .2
		btfss ZERO
		goto tr3_ld2
		bsf LOAD1
		goto ctrl_on4
tr3_ld2		bsf LOAD2
ctrl_on4	movf hr_on4,0
		movwf hr_tmp
		movf min_on4,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_on5
		movf load4,0
		btfsc ZERO
		goto ctrl_on5
		sublw .1
		btfss ZERO
		goto tr4_ld1
		bsf LIGHT
		goto ctrl_on5
tr4_ld1		movf load4,0
		sublw .2
		btfss ZERO
		goto tr4_ld2
		bsf LOAD1
		goto ctrl_on5
tr4_ld2		bsf LOAD2
ctrl_on5	movf hr_on5,0
		movwf hr_tmp
		movf min_on5,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_on6
		bsf T5_ON
		movf sec_off5,0
		movwf sec_cnt5
		movf load5,0
		btfsc ZERO
		goto ctrl_on6
		sublw .1
		btfss ZERO
		goto tr5_ld1
		bsf LIGHT
		goto ctrl_on6
tr5_ld1		movf load5,0
		sublw .2
		btfss ZERO
		goto tr5_ld2
		bsf LOAD1
		goto ctrl_on6
tr5_ld2		bsf LOAD2
ctrl_on6	movf hr_on6,0
		movwf hr_tmp
		movf min_on6,0
		movwf min_tmp
		call on_ctrl
		btfss ON_LOAD
		goto ctrl_off1
		bsf T6_ON
		movf sec_off6,0
		movwf sec_cnt6
		movf load6,0
		btfsc ZERO
		goto ctrl_off1
		sublw .1
		btfss ZERO
		goto tr6_ld1
		bsf LIGHT
		goto ctrl_off1
tr6_ld1		movf load6,0
		sublw .2
		btfss ZERO
		goto tr6_ld2
		bsf LOAD1
		goto ctrl_off1
tr6_ld2		bsf LOAD2
ctrl_off1	movf hr_off1,0
		movwf hr_tmp
		movf min_off1,0
		movwf min_tmp
		call off_ctrl
		btfss OFF_LOAD
		goto ctrl_off2
		movf load1,0
		btfsc ZERO
		goto ctrl_off2
		sublw .1
		btfss ZERO
		goto tr1_off1
		bcf LIGHT
		goto ctrl_off2
tr1_off1	movf load1,0
		sublw .2
		btfss ZERO
		goto tr1_off2
		bcf LOAD1
		goto ctrl_off2
tr1_off2	bcf LOAD2
ctrl_off2	movf hr_off2,0
		movwf hr_tmp
		movf min_off2,0
		movwf min_tmp
		call off_ctrl
		btfss OFF_LOAD
		goto ctrl_off3
		movf load2,0
		btfsc ZERO
		goto ctrl_off3
		sublw .1
		btfss ZERO
		goto tr2_off1
		bcf LIGHT
		goto ctrl_off3
tr2_off1	movf load2,0
		sublw .2
		btfss ZERO
		goto tr2_off2
		bcf LOAD1
		goto ctrl_off3
tr2_off2	bcf LOAD2
ctrl_off3	movf hr_off3,0
		movwf hr_tmp
		movf min_off3,0
		movwf min_tmp
		call off_ctrl
		btfss OFF_LOAD
		goto ctrl_off4
		movf load3,0
		btfsc ZERO
		goto ctrl_off4
		sublw .1
		btfss ZERO
		goto tr3_off1
		bcf LIGHT
		goto ctrl_off4
tr3_off1	movf load3,0
		sublw .2
		btfss ZERO
		goto tr3_off2
		bcf LOAD1
		goto ctrl_off4
tr3_off2	bcf LOAD2
ctrl_off4	movf hr_off4,0
		movwf hr_tmp
		movf min_off4,0
		movwf min_tmp
		call off_ctrl
		btfss OFF_LOAD
		return
		movf load4,0
		btfsc ZERO
		return
		sublw .1
		btfss ZERO
		goto tr4_off1
		bcf LIGHT
		return
tr4_off1	movf load4,0
		sublw .2
		btfss ZERO
		goto tr4_off2
		bcf LOAD1
		return
tr4_off2	bcf LOAD2
		return

ctrl_off5	;   5
		btfss T5_ON
		return
		movf sec_cnt5,0
		btfss ZERO
		return
		bcf T5_ON
		movf load5,0
		btfsc ZERO
		return
		sublw .1
		btfss ZERO
		goto tr5_off1
		bcf LIGHT
		return
tr5_off1	movf load5,0
		sublw .2
		btfss ZERO
		goto tr5_off2
		bcf LOAD1
		return
tr5_off2	bcf LOAD2
		return

ctrl_off6	;   6
		btfss T6_ON
		return
		movf sec_cnt6,0
		btfss ZERO
		return
		bcf T6_ON
		movf load6,0
		btfsc ZERO
		return
		sublw .1
		btfss ZERO
		goto tr6_off1
		bcf LIGHT
		return
tr6_off1	movf load6,0
		sublw .2
		btfss ZERO
		goto tr6_off2
		bcf LOAD1
		return
tr6_off2	bcf LOAD2
		return
		


wait50		movlw .12	; 50
		movwf count
loop50		nop
		decfsz count
		goto loop50
		return

clk_out		;    ()
		movf hr_tmp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7
		movwf d5
		movf ones,0
		call seg7
		movwf d6
		movf min_tmp,0
		movwf hexdata
		call convert
		movf decs,0
		call seg7
		movwf d8
		movf ones,0
		call seg7
		movwf d9
		movlw .1
		movwf d7
		return

sec_out		;   
		movf sec_tmp,0
		movwf hexdata
		call convert
		movf hunds,0
		call seg7
		movwf d6
		movf decs,0
		call seg7
		movwf d7
		movf ones,0
		call seg7
		movwf d8
		movlw 0
		movwf d5
		movwf d9
		return


convert		;   hexdata   
		;  hunds,decs,ones
		clrf hunds
   		clrf decs
lj_sotni        ;  
 		movlw .100
  		subwf hexdata,0
  		btfss CARRY
 		goto lj_des
 		movwf hexdata
 		incf hunds
  		goto lj_sotni
lj_des          ;  
   		movlw .10
   		subwf hexdata,0
   		btfss CARRY
  		goto lj_ed
  		movwf hexdata
  		incf decs
  		goto lj_des
lj_ed           ;  - 
  		movf hexdata,0
  		movwf ones
  		return

max20deg	; max 20 
		movf min_temp,0
		movwf max_temp
		return

min20deg	; min 20 
		clrf min_temp
		return
minus59		;  -59
		movlw .197
		movwf time_corr
		return

corr		; 
		btfsc CORR_BIT		;   
		goto end_corr
		bsf CORR_BIT
		btfsc time_corr,7	;  
		goto neg_corr
pos_corr	movf time_corr,0
		movwf seconds
		goto end_corr
neg_corr	comf time_corr,0	; .    	
		sublw .59
		movwf seconds
		movlw .59
		movwf minutes
		movlw .23
		movwf hours
end_corr	return

;  
lcd_dw		;  	
		movwf temp
		movf temp,0	
		andlw 0x0F
		iorlw 0x20
		movwf PORTB
		bsf lcd_rs	
		bcf lcd_e
		bsf lcd_e
		swapf temp,0	
		andlw 0x0F
		iorlw 0x20
		movwf PORTB
		bsf lcd_rs	
		bcf lcd_e	
		bsf lcd_e
		return

lcd_cw		;  	
		movwf temp
		movf temp,0	
		andlw 0x0F
		iorlw 0x20
		movwf PORTB
		bcf lcd_rs
		bcf lcd_e
		bsf lcd_e
		swapf temp,0	
		andlw 0x0F
		iorlw 0x20
		movwf PORTB
		bcf lcd_rs
		bcf lcd_e	
		bsf lcd_e
		return

message		; 
		;  count - - , count2 - .   , W -   
		addlw 0x20
		movwf FSR
msg_loop	movf count2,0
		call msg_tab
		movwf INDF
		incf FSR
		incf count2
		decfsz count
		goto msg_loop
		return

load_disp	;    
		movwf temp
		movlw .5		;- 
		movwf count
		movf temp,0
		btfss ZERO
		goto disp_lig
		movlw .0		;  
		movwf count2
		movlw .5		;
		call message
		return
disp_lig	movf temp,0
		sublw .1
		btfss ZERO
		goto disp_ld1
		movlw .10		;  
		movwf count2
		movlw .5		;
		call message
		return
disp_ld1	movf temp,0
		sublw .2
		btfss ZERO
		goto disp_ld2
		movlw .15		;  
		movwf count2
		movlw .5		;
		call message
		return
disp_ld2	movlw .20		;  
		movwf count2
		movlw .5		;
		call message
		return

disp_on		; On  
		movlw 0xee
		movwf d0 
		movlw 0x43
		movwf d1 
		clrf d2
		clrf d3
		clrf d4
		return

disp_off	; Off  
		movlw 0xee
		movwf d0 
		movlw 0x8b
		movwf d1 
		movlw 0x8b
		movwf d2 
		clrf d3
		clrf d4
		return

on_ctrl		; ?
		bcf ON_LOAD
		movf hr_tmp,0
		subwf hours,0
		btfss ZERO
		goto no_on
		movf min_tmp,0
		subwf minutes,0
		btfss ZERO
		goto no_on
		bsf ON_LOAD
no_on		return
off_ctrl	; ?
		bcf OFF_LOAD	
		movf hr_tmp,0
		subwf hours,0
		btfss ZERO
		goto no_off
		movf min_tmp,0
		subwf minutes,0
		btfss ZERO
		goto no_off
		bsf OFF_LOAD
no_off		return

flash_wr	clrwdt
		bsf STATUS,RP0		;  FLASH
		bsf EECON1,WREN
		bcf INTCON,GIE
		movlw 0x55
		movwf EECON2
		movlw 0xAA
		movwf EECON2
		bsf EECON1,WR
wr_loop		btfsc EECON1,WR
		goto wr_loop
		bcf EECON1,WREN
		bsf INTCON,GIE
		bcf STATUS,RP0
		return


flash_rd	bsf STATUS,RP0		;  FLASH
		bcf STATUS,RP1
		movwf EEADR
		bsf EECON1,RD
		movf EEDATA,0
		bcf STATUS,RP0
		return

	org 0x2100
		de 0,0,0,0,0,1,.10,.10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,.22,0,0,0,0,0,.13,.23,.26,0
	end
